<?php

if ( !defined( 'ABSPATH' ) ) {
	exit(); // Exit if accessed directly
}

/**
* Main Plugin class for pro plugin
*/

class IT_RST_RoosterStart_Pro {

	// Singleton design pattern
	protected static $instance = NULL;

	// Method to return the singleton instance
	public static function get_instance() {
		
		if ( null == self::$instance ) {
			self::$instance = new self();
		}

		return self::$instance;
	}

	public function __construct() {
		global $wp_version;
		if ( $wp_version >= 4.6 && $wp_version < 4.7 && !in_array( 'rest-api/plugin.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
		}
		else{
			add_action( 'plugins_loaded', array( $this, 'init' ) );
			$this->init_pro_modules();
		}
	}			
	
	public function init() {
		$this->includes();
    }
    
    // Includes pro modules
    public function init_pro_modules() {
	    require_once IT_RST_PLUGIN_PATH . 'modules/load-pro.php';
    }
    
    // Includes of our plugin PRO Version
	public function includes() {
	}
	
}