<?php
/*
 * Plugin Name: iThemes Sales Accelerator PRO
 * Plugin URI: https://ithemes.com/ithemes-sales-accelerator
 * Description: Transform your WordPress dashboard with dynamic reports so you can get detailed data and e-commerce insights about your WooCommerce store. 
 * Version: 1.0.3
 * Author: 20script
 * Author URI: http://www.20script.ir
 * Text Domain: ithemes-sales-accelerator
 * Domain Path: /assets/translations
 * License: GPLv2
 * iThemes Package: ithemes-salesacc-pro
 */

if (! defined('ABSPATH')) {
    exit(); // Exit if accessed directly
}

global $wpdb;

// Define some constants
define( 'IT_RST_PLUGIN_PREMIUM_ACTIVE', 1 );

// Show notice if both premium and free version are active
if( defined( 'IT_RST_PLUGIN_FREE_ACTIVE' ) ){
	add_action( 'admin_notices', 'it_sales_acc_show_notice_premium' );
}
else{
	define( 'IT_RST_PLUGIN_FILE', __FILE__ );
	define( 'IT_RST_PLUGIN_BASENAME', plugin_basename(__FILE__) );
	define( 'IT_RST_PLUGIN_PATH', plugin_dir_path(__FILE__) );
	define( 'IT_RST_PLUGIN_URL', plugin_dir_url(__FILE__) );
	define( 'IT_RST_PLUGIN_VERSION', 1.03 );
	define( 'IT_RST_PLUGIN_DATABASE_PREFIX', $wpdb->prefix . 'rst_' );
}

// Autoload required files
require_once dirname( __FILE__ ) . '/includes/rooster-start.php';
require_once dirname( __FILE__ ) . '/includes/class-rooster-menu.php';
require_once dirname( __FILE__ ) . '/includes/class-rooster-assets-loader.php';
require_once dirname( __FILE__ ) . '/includes/class-rooster-modules-controller.php';
require_once dirname( __FILE__ ) . '/includes/class-rooster-endpoints.php';
require_once dirname( __FILE__ ) . '/includes/class-rooster-permissions.php';
require_once dirname( __FILE__ ) . '/includes/admin/class-rooster-settings.php';
require_once dirname( __FILE__ ) . '/includes/classes/class-view-render.php';
require_once dirname( __FILE__ ) . '/includes/classes/class-rest-response.php';
require_once dirname( __FILE__ ) . '/includes/external/class-ithemes-api.php';

// Encapsulation of WooCommerce classes
require_once dirname( __FILE__ ) . '/includes/classes/woocommerce/class-wc-it-product.php';
require_once dirname( __FILE__ ) . '/includes/classes/woocommerce/class-wc-it-order.php';
require_once dirname( __FILE__ ) . '/includes/classes/woocommerce/class-wc-it-order-item.php';

require_once dirname( __FILE__ ) . '/includes/endpoints/class-rooster-authentication-rest.php';
require_once dirname( __FILE__ ) . '/includes/database/class-rooster-database.php';

// Autoload pro files
require_once dirname( __FILE__ ) . '/includes-pro/rooster-start-pro.php';


// Updater class
function it_rst_repository_name_updater_register( $updater ) { 
    $updater->register( 'ithemes-sales-accelerator', __FILE__ );
}
add_action( 'ithemes_updater_register', 'it_rst_repository_name_updater_register' );
require_once  dirname( __FILE__ ) . '/lib/updater/load.php';

IT_RST_RoosterStart::get_instance();

IT_RST_RoosterStart_Pro::get_instance();

// Activation and deactivation hooks
register_activation_hook(   IT_RST_PLUGIN_FILE, array( 'IT_RST_RoosterStart', 'activate_plugin' ) );
register_deactivation_hook( IT_RST_PLUGIN_FILE, array( 'IT_RST_RoosterStart', 'deactivate_plugin' ) );

function it_sales_acc_show_notice_premium(){
	// Show notice if both versions are active
	$ithemes_notice = __( 'You have both free and premium sales-acc plugins active. Please deactivate the free plugin.', 'ithemes-sales-accelerator' );
	echo "<div class='error'><p><strong>$ithemes_notice</strong></p></div>";
}