/**
* Handles dashboard calendar feature
**/

jQuery( document ).ready(function() {
	
	/*
	 * Initialize variables
	*/
	var start = moment().subtract( 29, 'days' );
    var end = moment();

	/*
	 * Calendar Button
	*/
	jQuery( '.rst_menu_calendar' ).daterangepicker({
        startDate: start,
        endDate: end,
        ranges: {
           'Today': [moment(), moment()],
           'Yesterday': [moment().subtract( 1, 'days' ), moment().subtract(1, 'days' )],
           'Last 7 Days': [moment().subtract( 6, 'days' ), moment()],
           'Last 30 Days': [moment().subtract( 29, 'days' ), moment()],
           'This Month': [moment().startOf( 'month' ), moment().endOf( 'month' )],
           'Last Month': [moment().subtract( 1, 'month' ).startOf( 'month' ), moment().subtract(1, 'month' ).endOf( 'month' )],
           '1Q of Year': [moment( '' + moment().year() + '-01-01' ), moment( '' + moment().year() + '-03-31' )],
           '2Q of Year': [moment( '' + moment().year() + '-01-04' ), moment( '' + moment().year() + '-06-30' )],
           '3Q of Year': [moment( '' + moment().year() + '-07-01' ), moment( '' + moment().year() + '-09-30' )],
           '4Q of Year': [moment( '' + moment().year() + '-10-01' ), moment( '' + moment().year() + '-12-31' )],
           'Always': [moment( rst_ajax_settings.start_date_shop ), moment()]
        }
    });
    
    jQuery( '.rst_menu_calendar' ).on( 'show.daterangepicker', function( ev, picker ) {
		jQuery( '.calendarBtt' ).addClass( 'active' );
	} );
	
	jQuery( '.rst_menu_calendar' ).on( 'hide.daterangepicker', function( ev, picker ) {
		jQuery( '.calendarBtt' ).removeClass( 'active' );
	} );
	
	jQuery( '.rst_menu_calendar' ).on( 'apply.daterangepicker', function( ev, picker ) {
		startDate 	= picker.startDate.format( 'YYYY-MM-DD' );
		endDate 	= picker.endDate.format( 'YYYY-MM-DD' );
		if ( picker.chosenLabel == 'Custom Range' || picker.chosenLabel == 'Always' || picker.chosenLabel == '1Q of Year' || picker.chosenLabel == '2Q of Year' || picker.chosenLabel == '3Q of Year' || picker.chosenLabel == '4Q of Year' ) {
			jQuery( '.selected_date' ).html(startDate + ' to ' + endDate );
		}
		else {
			jQuery( '.selected_date' ).html( picker.chosenLabel );
		}
			
		if (!(picker.chosenLabel == 'Today' || picker.chosenLabel == 'Yesterday' || picker.chosenLabel == 'Last 30 Days' )) {
			jQuery( '.rst_menu_calendar' ).addClass( 'active' );
			jQuery( '.search_buttons .today' ).removeClass( 'active' );
			jQuery( '.search_buttons .yesterday' ).removeClass( 'active' );
			jQuery( '.search_buttons .30days' ).removeClass( 'active' );
		}
		else {
			jQuery( '.rst_menu_calendar' ).removeClass( 'active' );
		}
			
		if ( picker.chosenLabel == 'Today' ) {
			jQuery( '.search_buttons .today' ).addClass( 'active' );
			jQuery( '.rst_menu_calendar' ).removeClass( 'active' );
			jQuery( '.search_buttons .yesterday' ).removeClass( 'active' );
			jQuery( '.search_buttons .30days' ).removeClass( 'active' );
		} else if ( picker.chosenLabel == 'Yesterday' ) {
			jQuery( '.search_buttons .yesterday' ).addClass( 'active' );
			jQuery( '.search_buttons .today' ).removeClass( 'active' );
			jQuery( '.search_buttons .30days' ).removeClass( 'active' );
			jQuery( '.rst_menu_calendar' ).removeClass( 'active' );
		} else if ( picker.chosenLabel == 'Last 30 Days' ) {
			jQuery( '.search_buttons .30days' ).addClass( 'active' );
			jQuery( '.search_buttons .yesterday' ).removeClass( 'active' );
			jQuery( '.search_buttons .today' ).removeClass( 'active' );
			jQuery( '.rst_menu_calendar' ).removeClass( 'active' );
		}
	} );
	
	/*
	 * Calendar Buttons (Yesterday, Today or 30 Days)
	*/
	jQuery( '.search_buttons .yesterday' ).click(function() {
		jQuery( '.search_buttons .30days' ).removeClass( 'active' );
		jQuery( '.search_buttons .today' ).removeClass( 'active' );
		jQuery( this ).addClass( 'active' );
		jQuery( 'li[data-range-key="Yesterday"]' ).click();
		jQuery( 'li[data-range-key="Yesterday"]' ).addClass( 'active' );
	});
	
	jQuery( '.search_buttons .today' ).click(function() {
		jQuery( '.search_buttons .30days' ).removeClass( 'active' );
		jQuery( '.search_buttons .yesterday' ).removeClass( 'active' );
		jQuery( this ).addClass( 'active' );
		jQuery( 'li[data-range-key="Today"]' ).click();
		jQuery( 'li[data-range-key="Today"]' ).addClass( 'active' );
	});
	
	jQuery( '.search_buttons .30days' ).click(function() {
		jQuery( '.search_buttons .yesterday' ).removeClass( 'active' );
		jQuery( '.search_buttons .today' ).removeClass( 'active' );
		jQuery( this ).addClass( 'active' );
		jQuery( 'li[data-range-key="Last 30 Days"]' ).click();
		jQuery( 'li[data-range-key="Last 30 Days"]' ).addClass( 'active' );
	} );	
	
} );