/**
* Handles grid pro features
**/

jQuery(document).ready( function() {   
	
	/*
	 * Function to save the positions of the Grid
	*/
	var isSending = false;
	
	saveGrid = function ( save ) {
		    
	    var newHeight = 0;
	    serializedData = _.map(jQuery( '.grid-stack > .grid-stack-item:visible' ), function ( el ) {
	
	        el = jQuery( el );
			
	        var node = el.data( '_gridstack_node' );
	
	        if ( 'undefined' !== typeof node ) {
	            newHeight = node.height;
	            if ( node.id == 0 ) {
		            newHeight = jQuery( '#' + node.id ).attr( 'data-gs-max-height' ); 
		        } else {
			        newHeight = node.height;
		        }
	
	            return {
	                x: jQuery( '#' + node.id ).attr( 'data-gs-x' ),
	                y: jQuery( '#' + node.id ).attr( 'data-gs-y' ),
	                width: jQuery( '#' + node.id ).attr( 'data-gs-width' ),
	                height: newHeight,
	                id: node.id,
	                slug: jQuery( '#' + node.id ).attr( 'data-gs-name' )
	            };
	        }
	    } );
	    
	    newserializedData = _.without( serializedData, undefined );
	    
	    if( save && isSending == false ) {
		    
	        var boxCoord = JSON.stringify( newserializedData, null, '    ' );

	        jQuery.ajax( {
		        url: rst_ajax_settings.root + 'it-sales-acc/v1/reporting/savegrid?boxCoord=' + boxCoord, 
			    method: 'GET',
		        beforeSend: function( xhr ){
			        isSending = true;
			        xhr.setRequestHeader( 'X-WP-Nonce', rst_ajax_settings.nonce );
			        grid = jQuery( '.grid-stack' ).data( 'gridstack' );
					grid.movable( '.grid-stack-item' ,false );
					jQuery( '.sd_div' ).show();
			   	},
			   	success: function() {
			       isSending = false;
				   grid = jQuery( '.grid-stack' ).data( 'gridstack' );
				   grid.movable( '.grid-stack-item', true );
				   grid.movable( '#0', false );
				   grid.movable( '#00', false );
				   grid.movable( '#7', false );
				   grid.movable( '.box-title', false );
				   jQuery( '.sd_div' ).hide();
			   	}
		    } );
	    }
	    return serializedData;
	}

	/*
	 * Action on Nested Grid - On Drag Stop
	*/
	var lastDraggedNode = undefined;
    jQuery( '.grid-stack.nested-grid' ).on( 'dragstop', function ( event, ui ) {
	    
		var element 	= jQuery( event.target );
		lastDraggedNode = element.data( '_gridstack_node' );
	} );
	
	/*
	 * Action on Nested Grid - On Drag Start
	*/
	jQuery( '.grid-stack.nested-grid' ).on( 'dragstart', function( event, ui ) {
	    serializedData  = saveGrid( false );
	});
	
	/*
	 * Action on Main Grid - On Drag Stop
	*/
	jQuery( '.grid-stack' ).on( 'change', function ( event, items ) {
	
		if ( lastDraggedNode ) {
			if ( lastDraggedNode.x % 4 ) {
				loadGridInit( false );
				return false;
			}
		}

		// Neste Grid 1
		var selected = undefined;
		var positions = ['01', '41', '81', '03', '43', '83', '04', '44', '84'];
		grid = jQuery( '.grid-stack.nested-grid' ).data( 'gridstack' );
		_.map( jQuery( '.grid-stack.nested-grid > .grid-stack-item:visible' ), function ( el ) {
            el = jQuery( el );
            var node = el.data( '_gridstack_node' );
            
            if ( node != undefined && node.y > 1 ) {
	            
	            if ( ( node.y == 4 && node.height == 2 ) || ( node.y == 5 && node.height == 1 ) || ( node.y == 6 && node.height == 1 ) || ( node.y == 5 && node.height == 2 ) ) {
		            selected = node;
	            } else {
		            if ( node.y > 1 ) {
			            var position = node.x.toString() + '' + node.y.toString();
						var index 	 = positions.indexOf( position );
						positions.splice(index,1);
					}
	            }
            }
        } );

        if ( selected != undefined ) {
	        if ( positions.length > 0 ) {
		        if ( ( selected.height == 2 && selected.y == 4 ) || ( selected.height == 1 && selected.y == 5 ) ) {
			        loadGridInit( false );
		        } else {
			        element = jQuery( '#' + selected.id );
					grid.update( element, parseInt( positions[0].charAt(0) ), parseInt( positions[0].charAt(1) ), selected.width, selected.height );
				}
        	}
        }
        
        // Neste Grid 2
		var selected2 = undefined;
		var positions2 = ['00','60'];
		grid2 = jQuery( '.grid-stack.nested-grid2' ).data( 'gridstack' );

		_.map( jQuery( '.grid-stack.nested-grid2 > .grid-stack-item:visible' ), function ( el ) {
            el = jQuery( el );
            var node2 = el.data( '_gridstack_node' );
            
	            if (node2.y == 4) {
		            selected2 = node2;
	            } else {
		            if ( node2.y == 0 ) {
			            var position2 = node2.x.toString() + '' + node2.y.toString();
						var index2 	  = positions2.indexOf( position2 );
						positions2.splice( index2, 1 );
					}
	            }
        } );

        if ( selected2 != undefined ) {
	        element2 = jQuery( '#' + selected2.id );
			grid2.update( element2, parseInt( positions2[0].charAt(0) ), parseInt( positions2[0].charAt(1) ), selected2.width, selected2.height );		
        }
        
        // Neste Grid 3
		var selected3 = undefined;
		var positions3 = ['01','31','61','91'];
		grid3 = jQuery( '.grid-stack.nested-grid3' ).data( 'gridstack' );

		_.map( jQuery( '.grid-stack.nested-grid3 > .grid-stack-item:visible' ), function ( el ) {
            el = jQuery( el );
            var node3 = el.data( '_gridstack_node' );
            
	            if ( node3.y == 2 ) {
		            selected3 = node3;
	            } else {
		            if ( node3.y == 1 ) {
			            var position3 = node3.x.toString() + '' + node3.y.toString();
						var index3 	  = positions3.indexOf( position3 );
						positions3.splice( index3, 1 );
					}
	            }
        } );

        if ( selected3 != undefined ) {
	        element3 = jQuery( '#' + selected3.id );
			grid3.update( element3, parseInt( positions3[0].charAt(0) ), parseInt( positions3[0].charAt(1) ), selected3.width, selected3.height );		
        }

		saveGrid( true );
	} );	
} );