/**
* Handles reporting pro util features
**/

jQuery( document ).ready(function() {
	
	/*
	 * Export data to CSV
	*/
	jQuery( '.rst_export_csv' ).click( function() {
		if ( typeof startDate == 'undefined' ) {
			dateS = 'empty';
		}
		else {
			dateS = startDate;
		}
			
		if ( typeof endDate == 'undefined' ) {
			dateE = 'empty';
		}
		else {
			dateE = endDate;
		}
		
		slug = jQuery( this ).parent().get(0).id;
		window.location.href = admin_url + 'admin.php?page=ithemes-sales-accelerator-plugin-export&slug=' + slug + '&dateStart=' + dateS + '&dateEnd=' + dateE;
	} );
	
	jQuery( '.rst_menu_calendar' ).on( 'apply.daterangepicker', function( ev, picker ) {
		
		// Abort all Ajax Calls to make the Dashboard refresh
		boxContentAjax.abort();
		tableContentAjax.abort();
		chartContentAjax.abort();
		
		// Refresh all Dashboard Data
		startDate 	= picker.startDate.format( 'YYYY-MM-DD' );
		endDate 	= picker.endDate.format( 'YYYY-MM-DD' );
		runFunctions( true );
	} );
	
	/*
	 * Refresh Data
	*/
	jQuery( '.refresh_data' ).click( function() {
		var rangeK = jQuery( '.ranges .active' ).attr('data-range-key' );	
		if ( typeof rangeK == 'undefined' ){
			rangeK = 'Last 30 Days';
		}
		jQuery( "li[data-range-key='" + rangeK + "']" ).click();
	} );
	
	/*
	 * Fullscreen Mode
	*/	
	if  ( screenfull.enabled ) {
		
		jQuery( '.rst_view_fullscreen' ).click( function() {
			screenfull.toggle( jQuery( '#wpcontent' )[0] );
		} );
		
		screenfull.on( 'change', () => {
			if ( screenfull.isFullscreen == true ) {
				jQuery( '#wpcontent' ).css( 'width', '100%' );
				jQuery( '#wpcontent' ).css( 'overflow-y', 'scroll' );
				jQuery( '#wpcontent' ).css( 'margin-left', '0' );	
				jQuery( '#wpadminbar' ).hide();
				jQuery( '.rst_view_fullscreen span' ).html( 'Exit' );
			}
			else {
				jQuery( '#wpcontent' ).css( 'overflow-y', 'hidden' );	
				jQuery( '#wpcontent' ).css( 'margin-left', '160px' );
				jQuery( '#wpadminbar' ).show();
				jQuery( '.rst_view_fullscreen span' ).html( 'Fullscreen' );
				jQuery( '#wpcontent').css( 'width', 'auto' );
			}
		} );
	} else {
		jQuery( '.rst_view_fullscreen' ).hide();
	}
	
} );