<?php
	
if ( !defined( 'ABSPATH' ) ) {
	exit(); // Exit if accessed directly
}

class IT_RST_RP_Box_Pro extends IT_RST_RP_Box {
    
    // Singleton design pattern
    protected static $instance = NULL;
    
    // Method to return the singleton instance
    public static function get_instance() {
	    
        if ( null == self::$instance ) {
            self::$instance = new self();
        }
        
        return self::$instance;
    }

    public function __construct() {}    
        	
	// Waiting Payment
    public function box_waitingPayment( $renderHtml ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->waitingPayment();
		
		if ( $renderHtml == '1' ) {
			$html = '<h6 class="pa_txt">' . __( 'Waiting Payment', 'ithemes-sales-accelerator' ) .'</h6>
					<span class="number_box_big">' . $content . '</span>
					';
			
			return array( 'html' => $html );
		}
		else {
			return array( 'total' => $content );
		}
	}
			
	// Availbale Qtt - Fast Fact
    public function box_availableQttFF( $renderHtml ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->availableQtt();
		
		if ( $renderHtml == '1' ) {
			$html = '<h6 class="pa_txt">' . __( 'Available Quantities', 'ithemes-sales-accelerator' ) .'</h6>
					<span class="number_box_big">' . $content . '</span>
					';
			
			return array( 'html' => $html );
		}
		else {
			return array( 'total' => $content );
		}
	}
	
	// Low Stock - Fast Fact
    public function box_lowStock( $renderHtml ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->lowStock();
		
		if ( $renderHtml == '1' ) {
			$html = '<h6 class="pa_txt">' . __( 'Low Stock Products', 'ithemes-sales-accelerator' ) .'</h6>
					<span class="number_box_big">' . $content . '</span>
					';
			
			return array( 'html' => $html );
		}
		else {
			return array( 'total' => $content );
		}
	}
		
	// Waiting to be Shipped
    public function box_waitingShipped($renderHtml) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->waitingShipped();
		
		if ( $renderHtml == '1' ) {
			$html = '<h6 class="pa_txt">' . __( 'Waiting to be Shipped', 'ithemes-sales-accelerator' ) .'</h6>
					<span class="number_box_big">' . $content . '</span>
					';
			
			return array( 'html' => $html );
		}
		else {
			return array( 'total' => $content );
		}
	}
		
	// Products Bought
    public function box_productsBought( $renderHtml = '', $dateStart, $dateEnd ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->productsBought( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$arrow = ( $content['variation'] >= 0 ? 'rst_arrow_up' : 'rst_arrow_down' );
			$html = '
	            	<div class="row" style="padding-top:5px;">
	            		<div class="col s12"><h6 class="pa_txt">' . __( 'Products Bought', 'ithemes-sales-accelerator' ) .'</h6></div>
	            	</div>
	            	<div class="row">
						<div class="col s12"><div id="chartFixedHeightContainer"><canvas id="products_bought"></canvas></div></div>
	            	</div>
	            	<div class="row">
						<div class="col s12 number_box">' . $content['total'];
	        if ( $content['variation'] != 0 ) {
		        $html .= do_shortcode( "[$arrow]" ) . ' <div class="tooltip"><span class="' . $arrow . '"> ' . $content['variation'] . ' %<span class="tooltiptext tooltip-top">' . __( 'Tooltip text', 'ithemes-sales-accelerator' ) .'</span></span></div>
		            		</div>
		            	</div>';
	        }
			
			return array( 'html' => $html, 'values' => $content['lines'] );
		}
		else {
			return $content;
		}
    }
    
    // Average Price Order
    public function box_averagePriceOrder( $renderHtml = '', $dateStart, $dateEnd ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->averagePriceOrder( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$arrow = ( $content['variation'] >= 0 ? 'rst_arrow_up' : 'rst_arrow_down' );
			$html = '
	            	<div class="row" style="padding-top:5px;">
	            		<div class="col s12"><h6 class="pa_txt">' . __( 'Average Order Amount', 'ithemes-sales-accelerator' ) .'</h6></div>
	            	</div>
	            	<div class="row">
						<div class="col s12"><div id="chartFixedHeightContainer"><canvas id="average_price_order"></canvas></div></div>
	            	</div>
	            	<div class="row">
						<div class="col s12 number_box">' . $content['total'];
	        if ( $content['variation'] != 0 ) {
		        $html .= do_shortcode( "[$arrow]" ) . ' <div class="tooltip"><span class="' . $arrow . '"> ' . $content['variation'] . ' %<span class="tooltiptext tooltip-top">' . __( 'Tooltip text', 'ithemes-sales-accelerator' ) .'</span></span></div>
		            		</div>
		            	</div>';
	        }
			
			return array( 'html' => $html, 'values' => $content['lines'] );
		}
		else {
			return $content;
		}
    }
    
    // Average Product per Order
    public function box_averagePriceProduct( $renderHtml = '', $dateStart, $dateEnd ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->averagePriceProduct( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$arrow = ( $content['variation'] >= 0 ? 'rst_arrow_up' : 'rst_arrow_down' );
			$html = '
	            	<div class="row" style="padding-top:5px;">
	            		<div class="col s12"><h6 class="pa_txt">' . __( 'Average Product per Order', 'ithemes-sales-accelerator' ) .'</h6></div>
	            	</div>
	            	<div class="row">
						<div class="col s12"><div id="chartFixedHeightContainer"><canvas id="average_price_product"></canvas></div></div>
	            	</div>
	            	<div class="row">
						<div class="col s12 number_box">' . $content['total'];
	        if ( $content['variation'] != 0 ) {
		        $html .= do_shortcode( "[$arrow]" ) . ' <div class="tooltip"><span class="' . $arrow . '"> ' . $content['variation'] . ' %<span class="tooltiptext tooltip-top">' . __( 'Tooltip text', 'ithemes-sales-accelerator' ) .'</span></span></div>
		            		</div>
		            	</div>';
	        }
			
			return array( 'html' => $html, 'values' => $content['lines'] );
		}
		else {
			return $content;
		}
    }
            
    // New Clients
    public function box_newClients( $renderHtml = '', $dateStart, $dateEnd ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->newClients( $dateStart,$dateEnd );

		if ( $renderHtml == '1' ) {
			$arrow = ( $content['variation'] >= 0 ? 'rst_arrow_up' : 'rst_arrow_down' );
			$html = '<div class="row" style="padding-top:3px;">
	            		<div class="col s12"><h6 class="pa_txt">' . __( 'New Customers', 'ithemes-sales-accelerator' ) .'</h6></div>
						<div class="col s12"><div id="chartFixedHeightContainer"><canvas id="new_clients"></canvas></div></div>
	            	</div>
	            	<div class="row" style="padding-top:3px;">
	            		<div class="col s12 number_box">' . $content['total'];
	        if ( $content['variation'] != 0 ) {
		        $html .= do_shortcode( "[$arrow]" ) . ' <div class="tooltip"><span class="' . $arrow . '"> ' . $content['variation'] . ' %<span class="tooltiptext tooltip-top">' . __( 'Tooltip text', 'ithemes-sales-accelerator' ) .'</span></span></div>
		            		</div>
		            	</div>';
	        }
			
			return array( 'html' => $html, 'values' => $content['lines'] );
		}
		else {
			return $content;
		}
    }
        
    // Best Product
    public function box_bestProduct($renderHtml = '', $dateStart, $dateEnd) {

		$content = RST_Reporting_Queries_Pro::get_instance()->bestProduct($dateStart,$dateEnd);
		$len = strlen( $content['name'] );
		
		if ( $len >= 20 ) {
			$name = substr( $content['name'], 0, 18 ) . '..';
		}
		else {
			$name = $content['name'];
		}
		
		if ( $renderHtml == '1' ) {
			$arrow = ( $content['variation'] >= 0 ? 'rst_arrow_up' : 'rst_arrow_down' );
			$html = '<div class="row" style="padding-top:3px;">
	            		<div class="col s12"><h6 class="pa_txt">' . __( 'Best Product', 'ithemes-sales-accelerator' ) .'</h6></div>
						<div class="col s12"><div id="chartFixedHeightContainer"><canvas id="best_product"></canvas></div></div>
	            	</div>
	            	<div class="row" style="padding-top:3px;">
	            		<div class="col s6 number_box">' . $name . '</div>
	            		<div class="col s6 variation_value">' . $content["total"];
	            	if ( $content['variation'] != 0 ) {
						$html .= '<div class="variation_data">' . do_shortcode( "[$arrow]" ) . ' <div class="tooltip"><span class="' . $arrow . '"> ' . $content['variation'] . ' %<span class="tooltiptext tooltip-top">' . __( 'Tooltip text', 'ithemes-sales-accelerator' ) .'</span></span></div></div></div>';
					}
					else { 
						$html .= '</div>';
					}
	        $html .= '</div>';			
			return array( 'html' => $html, 'values' => $content['lines'] );
		}
		else {
			return $content;
		}
    }
    
    // In Stock - Fast Fact
    public function box_inStock( $renderHtml ) {
		
		$content = RST_Reporting_Queries_Pro::get_instance()->inStock();
		
		if ( $renderHtml == '1' ) {
			$html = '<h6 class="pa_txt">' . __( 'Products In Stock', 'ithemes-sales-accelerator' ) .'</h6>
					<span class="number_box_big">' . $content . '</span>
					';
			
			return array( 'html' => $html );
		}
		else {
			return array( 'total' => $content );
		}
	}
	
	// Average Product Markup FF
	public function box_average_markup( $renderHtml ) {
		$content = RST_Reporting_Queries_Pro::get_instance()->averageMarkup();
		
		if ( $renderHtml == '1' ) {
			$html = '<h6 class="pa_txt">' . __( 'Average Markup', 'ithemes-sales-accelerator' ) .'</h6>
					<span class="number_box_big">' . $content . '</span>
					';
			
			return array( 'html' => $html );
		}
		else {
			return array( 'total' => $content );
		}
	}
            	
    // Send result by JSON Endpoint
    public function contentBox_json_endpoint( $request ) {
	    
	    $params = $request->get_params();
	    // Get params
	    $renderHtml = isset( $params['renderHtml'] ) ? $params['renderHtml'] : '';
	    $boxName 	= isset( $params['slug'] ) 		 ? $params['slug'] 		 : '';
	    $dateStart 	= isset( $params['dateStart'] )  ? $params['dateStart']  : date('Y-m-d',(strtotime ( '-30 days' ) ) );
	    $dateEnd 	= isset( $params['dateEnd'] ) 	 ? $params['dateEnd'] 	 : date('Y-m-d');

		$data = array( 'html' => '' );
		
		switch ( $boxName ) {
			
		    // Recent Orders
		    case 'recent_orders':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_recentOrders( $renderHtml );
		    	}
		    	else {
					$data = $this->box_recentOrders( '' );
				}
			break;
			
			// Products Available
		    case 'products_available':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_productsAvailable( $renderHtml );
		    	}
		    	else {
					$data = $this->box_productsAvailable( '' );
				}
			break;
			
			// Waiting to be Shipped
		    case 'waiting_shipped':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_waitingShipped( $renderHtml );
		    	}
		    	else {
					$data = $this->box_waitingShipped( '' );
				}
			break;
			
			// Total Customers
		    case 'total_customers':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_totalCustomers( $renderHtml );
		    	}
		    	else {
					$data = $this->box_totalCustomers( '' );
				}
			break;
			
			// Waiting Payment
		    case 'waiting_payment':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_waitingPayment( $renderHtml );
		    	}
		    	else {
					$data = $this->box_waitingPayment( '' );
				}
			break;
			
			// Products Bought
		    case 'products_bought':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_productsBought( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_productsBought( '', $dateStart, $dateEnd );
				}
			break;
			
			// Average Price Order
		    case 'average_price_order':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_averagePriceOrder( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_averagePriceOrder( '', $dateStart, $dateEnd );
				}
			break;
						
			// Average Price Product
		    case 'average_price_product':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_averagePriceProduct( $renderHtml, $dateStart, $dateEnd );
				}
		    	else {
					$data = $this->box_averagePriceProduct('', $dateStart, $dateEnd);
				}
			break;
						
			// Total Sales
		    case 'total_sales':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_totalSales( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_totalSales( '', $dateStart, $dateEnd );
				}
			break;
			
			// Total Coupons
		    case 'total_coupons':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_totalCoupons( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_totalCoupons( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Total Refunds
		    case 'total_refunds':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_totalRefunds( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_totalRefunds( '', $dateStart, $dateEnd );
				}
			break ;
			
			// New Clients
		    case 'new_clients':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_newClients( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_newClients( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Best Product
		    case 'best_product':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_bestProduct( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_bestProduct( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Best Category
		    case 'best_category':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_bestCategory( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_bestCategory('', $dateStart, $dateEnd );
				}
			break ;
			
			// Best Country
		    case 'best_country':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_bestCountry( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_bestCountry( '', $dateStart ,$dateEnd );
				}
			break ;
			
			// Best Shipping
		    case 'shipping_method':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_bestShipping( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->box_bestShipping( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Total Sales FF
		    case 'total_sales_ff':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_totalSalesFF( $renderHtml );
		    	}
		    	else {
					$data = $this->box_totalSalesFF( '' );
				}
			break ;
			
			// Available Qtt FF
		    case 'available_quantities_ff':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_availableQttFF( $renderHtml );
		    	}
		    	else {
					$data = $this->box_availableQttFF( '' );
				}
			break ;
			
			// Low Stock FF
		    case 'low_stock':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_lowStock( $renderHtml );
				}
		    	else {
					$data = $this->box_lowStock( '' );
				}
			break ;
			
			// Out of Stock FF
		    case  'out_of_stock':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_outStock( $renderHtml );
		    	}
		    	else {
					$data = $this->box_outStock( '' );
				}
			break ;
			
			// In Stock FF
		    case  'in_stock':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_inStock( $renderHtml );
		    	}
		    	else {
					$data = $this->box_inStock( '' );
				}
			break ;
			
			// Average Product Markup FF
			case  'average_markup':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->box_average_markup( $renderHtml );
		    	}
		    	else {
					$data = $this->box_average_markup( '' );
				}
			break ;
			
			default :
		    	return new IT_REST_Response( array( 'result' => false, 'data' => array() )  , 200 );
			break;
		}
	    
	    return new IT_REST_Response( array( 'result' => true, 'data' => $data )  , 200 );
    }
}