<?php
	
if ( !defined( 'ABSPATH' ) ) {
	exit(); // Exit if accessed directly
}

class IT_RST_RP_Table_Pro extends IT_RST_RP_Table {
    
    // Singleton design pattern
    protected static $instance = NULL;
    
    // Method to return the singleton instance
    public static function get_instance() {
	    
        if ( null == self::$instance ) {
            self::$instance = new self();
        }
        
        return self::$instance;
    }

    public function __construct() {}
        
    // Available Quantities
    public function table_availableQtt( $renderHtml ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->availableQtt_Table();

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Stock', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Price', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Value', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Stock', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Price', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Value', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {
		        $html .= '	<tr>
	            				<td class="sm-show"><a href="' . get_permalink( $item['product_id'] ) . '"><b><img src="' . $item['image'] . '" style="width:30px; height:30px;"></b></a></td>
	            				<td class="sm-hide s-hide">' . $item['name'] . '</td>
	            				<td class="s-hide sm-show">' . $item['stock'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['price'] . '</td>
	            				<td class="sm-show">' 		 . $item['total_value'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	           	}
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 4, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'name' => 'Name', 'stock' => 'Stock', 'price' => 'Price', 'total_value' => 'Total Value' ), 'values' => $content, 'order' => 4, 'order_by' => 'desc' );
		}
    }
    
    // Out of Stock
    public function table_outStock( $renderHtml ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->outofstock_Table();

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'SKU', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Price', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Backorders', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'SKU', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Price', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Backorders', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><a href="' . get_permalink( $item["product_id"] ) . '"><b><img src="' . $item["image"] . '" style="width:30px; height:30px;"></b></a></td>
	            				<td class="sm-hide s-hide">' . $item['name'] . '</td>
	            				<td class="s-hide sm-show">' . $item['sku'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['price'] . '</td>
	            				<td class="sm-show">' 		 . $item['backorders'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
            $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'asc' );
		}
		else {
			return array( 'columns' => array( 'name' => 'Name', 'sku' => 'SKU', 'price' => 'Price', 'backorders' => 'Backorders' ), 'values' => $content, 'order' => 1, 'order_by' => 'asc' );
		}
    }
    
    // In of Stock
    public function table_inStock( $renderHtml ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->inStock_Table();

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Stock', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Price', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Stock', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Price', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><a href="' . get_permalink( $item['product_id'] ) . '"><b><img src="' . $item['image'] . '" style="width:30px; height:30px;"></b></a></td>
	            				<td class="sm-hide s-hide">' . $item['name'] . '</td>
	            				<td class="s-hide sm-show">' . $item['stock'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['price'] . '</td>
	            				<td class="sm-show">' 		 . $item['total_value'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
            $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'asc' );
		}
		else {
			return array( 'columns' => array( 'name' => 'Name', 'stock' => 'Stock', 'price' => 'Price', 'total_value' => 'Total' ), 'values' => $content, 'order' => 1, 'order_by' => 'asc' );
		}
    }
    
    // Orders by Browsers
    public function table_ordersBrowsers( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->ordersBrowsers_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Browser', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Browser', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . $item['browser'] . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupons'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
            $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'browser' => 'Browser', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', 'coupons' => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }
    
    // Total Refunds
    public function table_totalRefunds( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->totalRefunds_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Order', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-hide s-hide">' . __( 'Date', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-hide s-hide">' . __( 'Status', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'Value Refunded', 'ithemes-sales-accelerator' ) .'</th>
								<th class="s-hide sm-show">' . __( 'Total Order', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Order', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-hide s-hide">' . __( 'Date', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-hide s-hide">' . __( 'Status', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'Value Refunded', 'ithemes-sales-accelerator' ) .'</th>
								<th class="s-hide sm-show">' . __( 'Total Order', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . $item['order_id'] . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['datetime'] . '</td>
	            				<td class="s-hide sm-show">' . $item['status'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['value_refunded'] . '</td>
	            				<td class="sm-show">' 	     . $item['total'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
            $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 4, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'order_id' => 'order', 'datetime' => 'Date', 'status' => 'Status', 'value_refunded' => 'Value Refunded', 'total' => 'Total Order' ), 'values' => $content, 'order' => 4, 'order_by' => 'desc' ) ;
		}
    }
        
    // Zone Distribution
    public function table_zoneDist( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->zoneDist_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Zone', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Zone', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['state'] ? $item['state'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupon'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
            $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'state' => 'Zone', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', 'coupon' => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }
    
    // Orders by OS Refunds
    public function table_ordersOS( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->ordersOS_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Platform', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 	 	 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Platform', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['platform'] ? $item['platform'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupons'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'platform' => 'Platform', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', 'coupons' => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' ) ;
		}
    }
    
    // Coupons
    public function table_coupons( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->coupons_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Coupon', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Coupon', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">'		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['coupon_name'] ? $item['coupon_name'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupons'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'coupon_name' => 'Coupon', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', 'coupons' => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }
    
    // Payment Methods
    public function table_paymentMethods( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->paymentMethod_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Payment', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Payment', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['payment'] ? $item['payment'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupons'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
				}
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else { 
			return array( 'columns' => array( 'payment' => 'Payment', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', 'coupons' => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }
    
    // Best Selling Products
    public function table_bestProducts( $renderHtml, $dateStart, $dateEnd ) {
	    
		$content = RST_Reporting_Queries_Pro::get_instance()->bestProducts_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Category', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Image', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Name', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Category', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
		        				<td class="sm-show"><a href="' . get_permalink( $item['product_id'] ) . '"><b><img src="' . $item['image'] . '" style="width:30px; height:30px;"></b></a></td>
	            				<td class="sm-show"><b>' 	 . ( $item['product'] ? $item['product'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . ( $item['category'] ? $item['category'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 2, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'product' => 'Name', 'total' => 'Total', 'category' => 'Category', 'num_products' => 'Num. Products' ), 'values' => $content, 'order' => 2, 'order_by' => 'desc' );
		}
    }
    
    // Product Type
    public function table_productType( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->productType_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-hide s-hide"><span style="padding-left: 25px;"></span>' . __( 'Product Type', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total Sales', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'Total Qtt', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Qtt Refunded', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'AVG Price', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-hide s-hide"><span style="padding-left: 25px;"></span>' . __( 'Product Type', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total Sales', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'Total Qtt', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Qtt Refunded', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'AVG Price', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['product_type'] ? $item['product_type'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['total_qtt'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['total_ref'] . '</td>
	            				<td class="sm-show">' 		 . $item['avg_price'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'product_type' => 'Product Type', 'total' => 'Total Sales', 'total_qtt' => 'Total Qtt', 'total_ref' => 'Total Qtt Refunded', 'avg_price' => 'AVG Price' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }

	// Best Category
    public function table_bestCategory( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->bestCategories_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-hide s-hide"><span style="padding-left: 25px;"></span>' . __( 'Product Type', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Category', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total Sales', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Qtt', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'AVG Price', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				               	<th class="sm-hide s-hide"><span style="padding-left: 25px;"></span>' . __( 'Product Type', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Category', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total Sales', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Qtt', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-show">' 		 . __( 'AVG Price', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {
		        
		        $category = $item["category"];
				
				$html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['product_type'] ? $item['product_type'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . ( $category ? $category : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</td>
	            				<td class="s-hide sm-show">' . $item['total'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['total_qtt'] . '</td>
	            				<td class="sm-show">' 		 . $item['avg_price'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 2, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'category' => 'Category', 'total' => 'Total Sales', 'total_qtt' => 'Total Qtt', 'avg_price' => 'AVG Price' ), 'values' => $content, 'order' => 2, 'order_by' => 'desc' );
		}
    }
    
    // Category Distribution by Country
    public function table_categoryCountry( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->categoryCountry_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Country', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 	     . __( 'Category', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Country', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Category', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . ( $item['country']  ? $item['country'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</b></td>
	            				<td class="sm-hide s-hide">' . ( $item['category'] ? $item['category'] : __( 'Unknown', 'ithemes-sales-accelerator' ) ) . '</td>
	            				<td class="s-hide sm-show">' . $item['total'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupon'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 2, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'country' => 'Country', 'category' => 'Category', 'total' => 'Total', 'num_products' => 'Num. Products', 'coupon' => 'Total Coupons' ), 'values' => $content, 'order' => 2, 'order_by' => 'desc' );
		}
    }
    
    // Spend by Week
    public function table_spendWeek( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->spendWeek_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Week', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Period', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Week', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 	     . __( 'Period', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .=	'<tr>
	            				<td class="sm-show"><b>' 	 . $item['week'] . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['period'] . '</td>
	            				<td class="s-hide sm-show">' . $item['total'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupon'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
            
            $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 2, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'week' => 'Week', 'period' => 'Period', 'total' => 'Total', 'num_products' => 'Num. Products', 'coupon' => 'Total Coupons' ), 'values' => $content, 'order' => 2, 'order_by' => 'desc' );
		}
    }

	// Spend by Hour
    public function table_spendHour( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->spendHour_Table( $dateStart, $dateEnd );
		
		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Hour', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Hour', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .=    '<tr>
	            				<td class="sm-show"><b>' 	 . $item['hour'] . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupon'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'hour' => 'Hour', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', "coupon" => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }
    
    // Order Status
    public function table_orderStatus( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->ordersStatus_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Status', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Status', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {

		        $html .=    '<tr>
	            				<td class="sm-show"><b>' 	 . $item['status'] . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupon'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'status' => 'Status', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', 'coupon' => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc' );
		}
    }
	    
    // Spend by day of Week
    public function table_spendDay( $renderHtml, $dateStart, $dateEnd ) {

		$content = RST_Reporting_Queries_Pro::get_instance()->spendDay_Table( $dateStart, $dateEnd );

		if ( $renderHtml == '1' ) {
			$html = '<table id="it_rst_dataTable" cellspacing="0" width="100%">
	            		<thead>
	            			<tr class="it_rst_dataTable_head">
	            				<th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Day', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
							</tr>
	            		</thead>
	            		<tfoot>
				            <tr>
				                <th class="sm-show"><span style="padding-left: 25px;"></span>' . __( 'Day', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="sm-show">' 		 . __( 'Total', 'ithemes-sales-accelerator' ) .'</th>
	            				<th class="s-hide sm-show">' . __( 'Num. Orders', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Num. Products', 'ithemes-sales-accelerator' ) .'</th>
								<th class="sm-hide s-hide">' . __( 'Total Coupons', 'ithemes-sales-accelerator' ) .'</th>
				            </tr>
				        </tfoot>
	            		<tbody>';
	        $i = 1;
	        foreach ( $content as $item ) {
		        
		        $html .='	<tr>
	            				<td class="sm-show"><b>' 	 . $item['day'] . '</b></td>
	            				<td class="sm-hide s-hide">' . $item['total'] . '</td>
	            				<td class="s-hide sm-show">' . $item['num_orders'] . '</td>
	            				<td class="sm-hide s-hide">' . $item['num_products'] . '</td>
	            				<td class="sm-show">' 		 . $item['coupon'] . '</td>
	            			</tr>';
	            $i++;
	            if ( $i == 40 ) {
	            	break;
	            }
	        }
	        
	        $html.= '</tbody></table>';
			
			return array( 'html' => $html, 'order' => 1, 'order_by' => 'desc' );
		}
		else {
			return array( 'columns' => array( 'day' => 'Day', 'total' => 'Total', 'num_orders' => 'Num. Orders', 'num_products' => 'Num. Products', "coupon" => 'Total Coupons' ), 'values' => $content, 'order' => 1, 'order_by' => 'desc', 'order' => 1, 'order_by' => 'desc' );
		}
    }
   
    // Send result by JSON Endpoint
    public function contentTable_json_endpoint( $request ){
	    
	    $params = $request->get_params();
	    // Get params
	    $renderHtml = isset( $params['renderHtml'] ) ? $params['renderHtml'] : '';
	    $tableName 	= isset( $params['slug'] ) 		 ? $params['slug'] 		 : '';
	    $dateStart 	= isset( $params['dateStart'] )  ? $params['dateStart']  : date( 'Y-m-d',(strtotime ( '-30 days' ) ) );
	    $dateEnd 	= isset( $params['dateEnd'] ) 	 ? $params['dateEnd'] 	 : date( 'Y-m-d' );
		
		switch ( $tableName ) {
			
		    // Best Customers
		    case 'best_customers':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_bestCustomers( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_bestCustomers( '', $dateStart, $dateEnd );
				}
			break;
			
			// Available Quantities
		    case 'available_quantities_ff':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_availableQtt( $renderHtml );
		    	}
		    	else {
					$data = $this->table_availableQtt( '' );
				}
			break;
			
			// Total Refunds
		    case 'total_refunds':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_totalRefunds( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_totalRefunds( '', $dateStart, $dateEnd );
				} 
			break;
			
			// Orders by Browsers
		    case 'orders_browsers':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_ordersBrowsers( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_ordersBrowsers( '', $dateStart, $dateEnd );
				}
			break;
			
			// Orders by OS
		    case 'orders_operating_system':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_ordersOS( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_ordersOS( '', $dateStart ,$dateEnd );
				}
			break;
			
			// Out of Stock
		    case 'out_of_stock':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_outStock( $renderHtml );
		    	}
		    	else {
					$data = $this->table_outStock( '' );
				}
			break;
			
			// In Stock
		    case 'in_stock':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_inStock( $renderHtml );
		    	}
		    	else {
					$data = $this->table_inStock( '' );
				}
			break;
			
			// Top Countries
		    case 'top_countries':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_topCountries( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_topCountries( '', $dateStart, $dateEnd );
				}
			break;
			
			// Coupons
		    case 'total_coupons':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_coupons( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_coupons( '', $dateStart, $dateEnd );
				}
			break;
			
			// Coupons
		    case 'payment_methods':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_paymentMethods( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_paymentMethods( '' ,$dateStart ,$dateEnd );
				}
			break;
			
			// Product Type
		    case 'type_products':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_productType( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_productType( '', $dateStart, $dateEnd );
				}
			break;
			
			// Best Category
		    case 'best_category':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_bestCategory( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_bestCategory( '', $dateStart, $dateEnd );
				}
			break;
			
			// Best Selling Products
		    case 'best_product':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_bestProducts( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_bestProducts( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Best Selling Products
		    case 'category_by_country':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_categoryCountry( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_categoryCountry( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Spend by Day
		    case 'spend_day':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_spendDay( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_spendDay( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Spend by Week
		    case 'spend_week':
		    	if ($renderHtml == '1') {
		    		$data = $this->table_spendWeek( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_spendWeek( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Spend by Hour
		    case 'spend_hour':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_spendHour( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_spendHour( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Orders Status
		    case 'orders_status':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_orderStatus( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_orderStatus( '', $dateStart, $dateEnd );
				}
			break ;
			
			// Zone Distribution
		    case 'zone_distribution':
		    	if ( $renderHtml == '1' ) {
		    		$data = $this->table_zoneDist( $renderHtml, $dateStart, $dateEnd );
		    	}
		    	else {
					$data = $this->table_zoneDist( '', $dateStart, $dateEnd );
				}
			break ;
			
			default :
		    	return new IT_REST_Response( array( 'result' => false, 'data' => array() )  , 200 );
			break;
		}
		
	    return new IT_REST_Response( array( 'result' => true, 'data' => $data )  , 200 );
    }
}