<?php
	
if ( !defined( 'ABSPATH' ) ) {
	exit(); // Exit if accessed directly
}

/**
* This class handles feature management endpoints
**/

class IT_RST_RP_Features {
    
    // Singleton design pattern
    protected static $instance = NULL;
    
    // Method to return the singleton instance
    public static function get_instance() {
	    
        if ( null == self::$instance ) {
            self::$instance = new self();
        }
        
        return self::$instance;
    }

    public function __construct() {}    

    // Process reporting timers form
    public function set_reporting_timers_json( $request ) {
	    
	    $params = $request->get_params();
	    
	    if ( isset( $params['form'] ) ) {
		    $form   = $params['form'];
		    $values = array();
			parse_str( $form, $values );
			
			if( isset( $values['it_rooster_reporting_features'] ) ) {
				$it_rooster_reporting_features = $values['it_rooster_reporting_features'];					
				update_option( 'it_rooster_reporting_features', $it_rooster_reporting_features );
				
			    return new IT_REST_Response( array( 'result' => true, 'data' => array() )  , 200 );	 
		    }
	    }   
	    
	    return new IT_REST_Response( array( 'result' => false, 'data' => array() )  , 200 );
    }
    
    public function set_reporting_timers() {
	    
	    return true;
    }
    
    // Get reporting module options
    public function get_reporting_options_json( $request ) {
	    
	    $options = $this->get_reporting_options();
	    return new IT_REST_Response( array( 'result' => false, 'data' => $options )  , 200 );
    }
    
    public function get_reporting_options() {
	    
	    global $wpdb, $it_rst_reporting_feature_settings, $it_rst_dashboard_settings;
	    
	    $features = RST_Reporting_Features::get_instance();
	    $key 	  = $_SERVER['PHP_AUTH_USER'];
		$secret   = $_SERVER['PHP_AUTH_PW'];
		$user_obj = IT_RST_RP_Menu::get_user_by_wc_keys( $key, $secret );
		$user_id  = ( isset( $user_obj->ID ) && $user_obj->ID ) ? $user_obj->ID : 0;
			    	    
	    $box_coord = json_decode( get_user_meta( $user_id, 'it_rooster_box_coord', TRUE ) );
	    
	    if ( !is_array( $box_coord ) ) {
		    $box_coord = array();
	    }
	    	    
	    // Get feature name
	    foreach ( $it_rst_reporting_feature_settings as $k => $v ) {
		    $it_rst_reporting_feature_settings[$k]['name'] = $features->get_feature_name_by_key( $k );
		    
		    foreach ( $box_coord as $box ) {
			    if ( isset( $box->slug ) && $box->slug == $k ) {
				    $it_rst_reporting_feature_settings[ $k ]['coordinates'] = array( 'x' => $box->x, 'y' => $box->y, 'width' => $box->width, 'height' => $box->height );
				    break;
			    }
		    } 
	    }
	    
	    $options = array( 'features' => $it_rst_reporting_feature_settings, 'dashboard' => $it_rst_dashboard_settings );
	    return $options;
    }
}